# Changelog

All notable changes to this project will be documented in this file.

フォーマットは [Keep a Changelog](https://keepachangelog.com/ja/1.1.0/) に準じる。
バージョンの付けかたは [Semantic Versioning](https://semver.org/spec/v2.0.0.html) に準じる。

## [Unreleased]

## [3.1.2] - 2024-10-19

### Fixed

- 辞書の見出しに数字が含まれている時に#4を含むエントリ以外では変換候補にならない問題を修正。数値自体を見出しに含む候補と数値置換候補があった場合、常に完全一致の候補の方が優先される。 (辞書のエントリ上、双方にマッチする時に各々の候補の別見出しの候補に対しての優先順位を保持する事が不可能なため。)

## [3.1.1] - 2024-03-05

### Fixed

- 辞書内のアノテーションに角括弧 ('[',']')が含まれている時に正しく読み込まれない問題を修正

## [3.1.0] - 2023-12-28

### Changed

- モード遷移を修正し、無限に深いモード遷移をできないように修正。Registerの入れ子を10回までに制限する。
- Abortで変換確定前の状態に戻ってstateがおかしい状態になることを修正するため、変換確定時に自動的にデフォルトのモードに戻るように"Abort"
  の処理を変更。それに応じてルールファイルを修正。
- MSRVを1.60(2022-04)から1.64 (2022-09)に変更。

### Fixed

- AZIKモードの重複したかな変換ルールを削除。
- default,AZIKモードの送り仮名時のC-gのルールを修正。
- cargo-deb のアップデートにともなって出力debファイル名が変わっていたものを修正

## [3.0.0] - 2023-02-05

### Added

- 補完機能の追加。補完に用いると指定した辞書の送りがな無しエントリを補完候補として出す。
- AZIKのrulesファイルにSKK向け独自拡張の「っ」の入力方法を追加

### Changed

- 補完機能のためAPIインタフェース変更。
- 一部モードの状態に確定済み文字列を返すように変更。
- Abortコマンドの挙動変更、単体で直前のモードに戻すように。
- rulesファイルのAbortを使っていた部分の修正。
- rulesファイルに補完モード関連のキーを追加。

### Fixed

- Tabが単体で押されていた時と他のキーと同時に押されていた時に違うキーとして扱われていた問題を修正。

## [2.0.0]

### Changed

- APIインタフェースのバグ修正による変更。

## [1.0.0]
